---
# tasks file for dsg-role-mariadb
- include_tasks: variables.yml

- name: Include OS-specific repository.
  include: "prepa-{{ ansible_os_family }}.yml"

- name : Install mariadb server
  package: 
    name: mariadb-server
    state: present

- include_tasks: configure.yml

- name: Ensure MySQL is started and enabled on boot.
  service: 
    name: mariadb
    state: started 
    enabled: yes

- name: Set password root.
  include: "password-root.yml"
  
- name: Remove anonymous MySQL users
  mysql_user:
    login_unix_socket: "{{ mysql_socket }}"
    name: ""
    host_all: yes
    state: absent

- name: check if DB test exists
  command: "mysql -NBe 'SHOW DATABASES;' | grep test"
  register: dbstatus
  failed_when: dbstatus.rc == 2

- name: Remove MySQL test database.
  mysql_db:
    login_unix_socket: "{{ mysql_socket }}"
    name: test
    login_host : localhost
    state: absent
  when: dbstatus|length > 0 

- name: Ensure MySQL databases are present.
  mysql_db:
    login_unix_socket: "{{ mysql_socket }}"
    name: "{{ item.name }}"
    collation: "{{ item.collation | default('utf8_general_ci') }}"
    encoding: "{{ item.encoding | default('utf8') }}"
    state: "{{ item.state | default('present') }}"
  with_items: "{{ mysql_databases }}"

- name: Ensure MySQL users are present.
  mysql_user:
    name: "{{ item.name }}"
    password: "{{ item.password }}"
    priv: "{{ item.priv | default('*.*:USAGE') }}"
    state: present
  with_items: "{{ mysql_users }}"
  register: command_result
  failed_when: "'unable to connect to database' in command_result"
